import 'package:flutter/material.dart';
import 'package:font_awesome_flutter/font_awesome_flutter.dart';
import 'package:gap/gap.dart';
import 'package:go_router/go_router.dart';
import 'package:pharmacy_mobile/auth/auth_service.dart';
import 'package:pharmacy_mobile/widgets/button_widget.dart';
import 'package:pharmacy_mobile/widgets/menu_widget.dart';
import 'package:pharmacy_mobile/widgets/page_background_widget.dart';
import 'package:pharmacy_mobile/widgets/snackbar_widget.dart';
import 'package:pharmacy_mobile/widgets/text_widget.dart';
import 'package:pharmacy_mobile/widgets/title_widget.dart';

class MainPage extends StatelessWidget {
  const MainPage({super.key});

  @override
  Widget build(BuildContext context) {
    final authService = AuthService();

    void signOut() async {
      await authService.signOut().then((_) => {context.push('/'), showNotification(context, 'Logged Out', true)});
    }

    return PopScope(
        canPop: false,
        child: Scaffold(
          resizeToAvoidBottomInset: false,
          body: SingleChildScrollView(
            child: PageBackgroundWidget(
              page: 'menu',
              child: Center(
                child: Column(
                  children: [
                    const Gap(96),
                    const TitleWidget(firstTextSize: 20, secondTextSize: 32),
                    const Gap(32),
                    const TextWidget(text: 'Menu'),
                    const Gap(16),
                    MenuWidget(
                        icon: FontAwesomeIcons.squarePlus,
                        text: 'Add Type',
                        onPressed: () => {context.push('/addtype')},
                        color: 'blue'),
                    const Gap(16),
                    MenuWidget(
                        icon: FontAwesomeIcons.squarePlus,
                        text: 'Add Category',
                        onPressed: () => {context.push('/addcategory')},
                        color: 'blue'),
                    const Gap(16),
                    MenuWidget(
                        icon: FontAwesomeIcons.squarePlus,
                        text: 'Add Generics',
                        onPressed: () => {context.push('/addgenerics')},
                        color: 'blue'),
                    const Gap(32),
                    MenuWidget(
                        icon: FontAwesomeIcons.squarePlus,
                        text: 'Add Medicine',
                        onPressed: () => {context.push('/addmedicines')},
                        color: 'green'),
                    const Gap(16),
                    MenuWidget(
                        icon: FontAwesomeIcons.squarePlus,
                        text: 'Add Stock',
                        onPressed: () => {context.push('/addstock')},
                        color: 'green'),
                    const Gap(32),
                    MenuWidget(
                        icon: FontAwesomeIcons.listCheck,
                        text: 'List of Stocks',
                        onPressed: () => {context.push('/liststocks')},
                        color: 'yellow'),
                    const Gap(40),
                    ButtonWidget(
                      text: 'Logout',
                      onPressed: signOut,
                    )
                  ],
                ),
              ),
            ),
          ),
        ));
  }
}
